# Systemwide variables needed by the SHADOW package
#
# std.ph           - SHADOW release 1.6
#                    Last changed 25 Aug 1999
#
# Author: Olav Kolbu <olav.kolbu@usit.uio.no>
# Editor: Bill Ralph <wralph@nswc.navy.mil>
#
# This code is hereby released into the public domain. It is released
# "as-is". All warranties disclaimed, implied or otherwise.
#

use POSIX qw(strftime);
use Time::Local;

# We need various timestamps all over the place. Set these variables
# according to your preferences. If you have sensors crossing time zones,
# you might need GMT(UTC).
#
#@T = gmtime(time);
#$TZ = "GMT";
#
@T = localtime(time);
$TZ = "LOC";   

# The location of the scripts to be run on the sensor machine.
#
*PROGLOC  = $SENSOR_PATH;

# The full path to the 'tcpdump' program
$LOGPROG  = "/usr/sbin/tcpdump";	# RH Linux 5.x
$PROGPAR  = "-i eth0";			# Parameter necessary for Linux

# The full path to the 'gzip' program
$GZIPPROG = "/bin/gzip";		# RH Linux 5.1

# The log directory
$LOGDIR   = "/LOG/std";

# The name of the current logfile
#
$tmp2 = strftime("%y%m%d%H", @T);
$tmp4 = strftime("%Y%m%d%H", @T);
$LOG2FILE = "tcp.$tmp2.gz";
$LOG4FILE = "tcp.$tmp4.gz";
$TCPLOG2   = "$LOGDIR/$LOG2FILE";
$TCPLOG4   = "$LOGDIR/$LOG4FILE";

